Index: trunk/NEMO/OPA_SRC/restart.F90
===================================================================
--- trunk/NEMO/OPA_SRC/restart.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/restart.F90	(revision 888)
@@ -19,6 +19,4 @@
    USE phycst          ! physical constants
    USE daymod          ! calendar
-   USE ice_oce         ! ice variables
-   USE blk_oce         ! bulk variables
    USE cpl_oce, ONLY : lk_cpl              !
    USE in_out_manager  ! I/O manager
@@ -43,5 +41,5 @@
    !!----------------------------------------------------------------------
    !!  OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/restart.F90,v 1.27 2007/06/05 10:35:19 opalod Exp $ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -143,19 +141,4 @@
       CALL iom_rstput( kt, nitrst, numrow, 'rotn'   , rotn    )
       CALL iom_rstput( kt, nitrst, numrow, 'hdivn'  , hdivn   )
-
-#if defined key_lim3 || defined key_lim2
-      CALL iom_rstput( kt, nitrst, numrow, 'nfice'  , REAL( nfice, wp) )   !  ice computation frequency
-      CALL iom_rstput( kt, nitrst, numrow, 'sst_io' , sst_io  )
-      CALL iom_rstput( kt, nitrst, numrow, 'sss_io' , sss_io  )
-      CALL iom_rstput( kt, nitrst, numrow, 'u_io'   , u_io    )
-      CALL iom_rstput( kt, nitrst, numrow, 'v_io'   , v_io    )
-# if defined key_coupled
-      CALL iom_rstput( kt, nitrst, numrow, 'alb_ice', alb_ice )
-# endif
-#endif
-#if defined key_flx_bulk_monthly || defined key_flx_bulk_daily || defined key_flx_core 
-      CALL iom_rstput( kt, nitrst, numrow, 'nfbulk' , REAL( nfbulk, wp) )   !  bulk computation frequency
-      CALL iom_rstput( kt, nitrst, numrow, 'gsst'   , gsst    )
-#endif
 
       IF( nn_dynhpg_rst == 1 .OR. lk_vvl ) THEN
@@ -209,8 +192,5 @@
       !!                    has been stored in the restart file.
       !!----------------------------------------------------------------------
-      REAL(wp) ::   zcoef, zkt, zrdt, zrdttra1, zndastp, znfice, znfbulk
-#if defined key_lim3 || defined key_lim2
-      INTEGER  ::   ji, jj
-#endif
+      REAL(wp) ::   zkt, zrdt, zrdttra1, zndastp
       !!----------------------------------------------------------------------
 
@@ -304,62 +284,4 @@
       ENDIF
 
-      !!sm: TO BE MOVED IN NEW SURFACE MODULE...
-
-#if defined key_lim3 || defined key_lim2
-      ! Louvain La Neuve Sea Ice Model
-      IF( iom_varid( numror, 'nfice', ldstop = .FALSE. ) > 0 ) then 
-         CALL iom_get( numror             , 'nfice'  , znfice  )   ! ice computation frequency
-         CALL iom_get( numror, jpdom_autoglo, 'sst_io' , sst_io  )
-         CALL iom_get( numror, jpdom_autoglo, 'sss_io' , sss_io  )
-         CALL iom_get( numror, jpdom_autoglo, 'u_io'   , u_io    )
-         CALL iom_get( numror, jpdom_autoglo, 'v_io'   , v_io    )
-# if defined key_coupled
-         CALL iom_get( numror, jpdom_autoglo, 'alb_ice', alb_ice )
-# endif
-         IF( znfice /= REAL( nfice, wp ) ) THEN      ! if nfice changed between 2 runs
-            zcoef = REAL( nfice-1, wp ) / znfice
-            sst_io(:,:) = zcoef * sst_io(:,:)
-            sss_io(:,:) = zcoef * sss_io(:,:)
-            u_io  (:,:) = zcoef * u_io  (:,:)
-            v_io  (:,:) = zcoef * v_io  (:,:)
-         ENDIF
-      ELSE
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'rst_read :  LLN sea Ice Model => Ice initialization'
-         IF(lwp) WRITE(numout,*)
-         zcoef = REAL( nfice-1, wp )
-         sst_io(:,:) = zcoef *( tn(:,:,1) + rt0 )          !!bug a explanation is needed here!
-         sss_io(:,:) = zcoef *  sn(:,:,1)
-         zcoef = 0.5 * REAL( nfice-1, wp )
-         DO jj = 2, jpj
-            DO ji = fs_2, jpi   ! vector opt.
-               u_io(ji,jj) = zcoef * ( un(ji-1,jj  ,1) + un(ji-1,jj-1,1) )
-               v_io(ji,jj) = zcoef * ( vn(ji  ,jj-1,1) + vn(ji-1,jj-1,1) )
-            END DO
-         END DO
-# if defined key_coupled
-         alb_ice(:,:) = 0.8 * tmask(:,:,1)
-# endif
-      ENDIF
-#endif
-#if defined key_flx_bulk_monthly || defined key_flx_bulk_daily || defined key_flx_core 
-      ! Louvain La Neuve Sea Ice Model
-      IF( iom_varid( numror, 'nfbulk', ldstop = .FALSE. ) > 0 ) THEN 
-         CALL iom_get( numror             , 'nfbulk', znfbulk )   ! bulk computation frequency
-         CALL iom_get( numror, jpdom_autoglo, 'gsst'  , gsst    )
-         IF( znfbulk /= REAL(nfbulk, wp) ) THEN      ! if you change nfbulk between 2 runs
-            zcoef = REAL( nfbulk-1, wp ) / znfbulk
-            gsst(:,:) = zcoef * gsst(:,:)
-         ENDIF
-      ELSE
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'rst_read :  LLN sea Ice Model => Ice initialization'
-         IF(lwp) WRITE(numout,*)
-         gsst(:,:) = REAL( nfbulk - 1, wp )*( tn(:,:,1) + rt0 )
-      ENDIF
-#endif
-
-      !!sm: end of TO BE MOVED IN NEW SURFACE MODULE...
-
       IF( iom_varid( numror, 'rhd', ldstop = .FALSE. ) > 0 ) THEN
          CALL iom_get( numror, jpdom_autoglo, 'rhd' , rhd  )
Index: trunk/NEMO/OPA_SRC/step.F90
===================================================================
--- trunk/NEMO/OPA_SRC/step.F90	(revision 873)
+++ trunk/NEMO/OPA_SRC/step.F90	(revision 888)
@@ -4,6 +4,5 @@
    !! Time-stepping    : manager of the ocean, tracer and ice time stepping
    !!======================================================================
-   !! History :        !  91-03  ()  Original code
-   !!                  !  91-11  (G. Madec)
+   !! History :        !  91-03  (G. Madec)  Original code
    !!                  !  92-06  (M. Imbard)  add a first output record
    !!                  !  96-04  (G. Madec)  introduction of dynspg
@@ -20,4 +19,7 @@
    !!             " "  !  06-01  (L. Debreu, C. Mazauric)  Agrif implementation
    !!             " "  !  06-07  (S. Masson)  restart using iom
+   !!             " "  !  06-08  (G. Madec)  surface module 
+   !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   stp            : OPA system time-stepping
@@ -30,5 +32,5 @@
    USE cpl_oce         ! coupled ocean-atmosphere variables
    USE in_out_manager  ! I/O manager
-   USE iom
+   USE iom             !
    USE lbclnk
 
@@ -37,12 +39,6 @@
    USE dtatem          ! ocean temperature data           (dta_tem routine)
    USE dtasal          ! ocean salinity    data           (dta_sal routine)
-   USE dtasst          ! ocean sea surface temperature    (dta_sst routine)
-   USE dtasss          ! ocean sea surface salinity       (dta_sss routine)
-   USE taumod          ! surface stress                   (tau     routine)
-   USE flxmod          ! thermohaline fluxes              (flx     routine)
-   USE ocesbc          ! thermohaline fluxes              (oce_sbc routine)
-   USE flxrnf          ! runoffs                          (flx_rnf routine)
-   USE flxfwb          ! freshwater budget correction     (flx_fwb routine)
-   USE closea          ! closed sea freshwater budget     (flx_clo routine)
+   USE sbcmod          ! surface boundary condition       (sbc     routine)
+   USE sbcrnf          ! surface boundary condition: runoff variables
    USE ocfzpt          ! surface ocean freezing point    (oc_fz_pt routine)
 
@@ -96,10 +92,5 @@
    USE zpshde          ! partial step: hor. derivative     (zps_hde routine)
    USE ice_oce         ! sea-ice variable
-#if defined key_lim3
-   USE icestp          ! sea-ice time-stepping             (ice_stp routine)
-#endif
-#if defined key_lim2
-   USE icestp_2        ! sea-ice time-stepping             (ice_stp_2 routine)
-#endif
+
    USE diawri          ! Standard run outputs             (dia_wri routine)
    USE trdicp          ! Ocean momentum/tracers trends    (trd_wri routine)
@@ -119,5 +110,4 @@
    USE stpctl          ! time stepping control            (stp_ctl routine)
    USE restart         ! ocean restart                    (rst_wri routine)
-   USE cpl             ! exchanges in coupled mode        (cpl_stp routine)
    USE prtctl          ! Print control                    (prt_ctl routine)
    USE domvvl          ! variable volume                  (dom_vvl routine)
@@ -137,5 +127,5 @@
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/step.F90,v 1.35 2007/06/01 16:55:39 opalod Exp $ 
+   !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
    !!----------------------------------------------------------------------
@@ -166,10 +156,9 @@
       !! * Arguments
 #if defined key_agrif   
-      INTEGER               :: kstp   ! ocean time-step index
+      INTEGER             ::   kstp   ! ocean time-step index
 #else
-      INTEGER, INTENT( in ) :: kstp   ! ocean time-step index
+      INTEGER, INTENT(in) ::   kstp   ! ocean time-step index
 #endif      
-
-      !! * local declarations
+      INTEGER ::   jk       ! dummy loop indice
       INTEGER ::   indic    ! error indicator if < 0
       !! ---------------------------------------------------------------------
@@ -182,6 +171,4 @@
       indic = 1                    ! reset to no error condition
 
-      adatrj = adatrj + rdt/86400._wp
-
       CALL day( kstp )             ! Calendar
 
@@ -189,55 +176,18 @@
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-      ! Update data, open boundaries and Forcings
+      ! Update data, open boundaries, surface boundary condition (including sea-ice)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 
       IF( lk_dtatem  )   CALL dta_tem( kstp )         ! update 3D temperature data
-
-      IF( lk_dtasal  )   CALL dta_sal( kstp )         ! Salinity data
-
-      IF( lk_dtasst  )   CALL dta_sst( kstp )         ! Sea Surface Temperature data
-
-      IF( lk_dtasss  )   CALL dta_sss( kstp )         ! Sea Surface Salinity data
+      IF( lk_dtasal  )   CALL dta_sal( kstp )         ! update 3D salinity data
+
+                         CALL sbc    ( kstp )         ! Sea Boundary Condition (including sea-ice)
 
       IF( lk_obc     )   CALL obc_dta( kstp )         ! update dynamic and tracer data at open boundaries
-
       IF( lk_obc     )   CALL obc_rad( kstp )         ! compute phase velocities at open boundaries
 
-      IF( .NOT. lk_core )    CALL tau( kstp )         ! wind stress
-
-                         CALL flx_rnf( kstp )         ! runoff data
-
-                         CALL flx( kstp )             ! heat and freshwater fluxes
-
-#if defined key_lim3
-      CALL ice_stp( kstp )           ! sea-ice model (Update stress & fluxes)
-#endif
-#if defined key_lim2
-      CALL ice_stp_2( kstp )         ! sea-ice model (Update stress & fluxes)
-#endif
-
-                         CALL oce_sbc( kstp )         ! ocean surface boudaries
-
-      IF( ln_fwb     )   CALL flx_fwb( kstp )         ! freshwater budget
-
-      IF( nclosea == 1 ) CALL flx_clo( kstp )         ! closed sea in the domain (update freshwater fluxes)
-
-      IF( kstp == nit000 ) THEN 
-         IF( ninist == 1 ) THEN                       ! Output the initial state and forcings
-            CALL dia_wri_state( 'output.init' )
-         ENDIF
-      ENDIF
-
-      IF(ln_ctl) THEN         ! print mean trends (used for debugging)
-         CALL prt_ctl(tab2d_1=emp    , clinfo1=' emp  -   : ', mask1=tmask, ovlap=1)
-         CALL prt_ctl(tab2d_1=emps   , clinfo1=' emps -   : ', mask1=tmask, ovlap=1)
-         CALL prt_ctl(tab2d_1=qt     , clinfo1=' qt   -   : ', mask1=tmask, ovlap=1)
-         CALL prt_ctl(tab2d_1=qsr    , clinfo1=' qsr  -   : ', mask1=tmask, ovlap=1)
-         CALL prt_ctl(tab2d_1=runoff , clinfo1=' runoff   : ', mask1=tmask, ovlap=1)
-         CALL prt_ctl(tab3d_1=tmask  , clinfo1=' tmask    : ', mask1=tmask, ovlap=1, kdim=jpk)
-         CALL prt_ctl(tab3d_1=tn     , clinfo1=' sst  -   : ', mask1=tmask, ovlap=1, kdim=1)
-         CALL prt_ctl(tab3d_1=sn     , clinfo1=' sss  -   : ', mask1=tmask, ovlap=1, kdim=1)
-         CALL prt_ctl(tab2d_1=taux   , clinfo1=' tau  - x : ', mask1=umask, &
-            &         tab2d_2=tauy   , clinfo2='      - y : ', mask2=vmask,ovlap=1)
+      IF( ninist == 1 ) THEN                       ! Output the initial state and forcings
+                        CALL dia_wri_state( 'output.init' )
+                        ninist = 0
       ENDIF
 
@@ -252,5 +202,5 @@
       !-----------------------------------------------------------------------
 
-                       CALL bn2( tb, sb, rn2 )              ! before Brunt-Vaisala frequency
+                        CALL bn2( tb, sb, rn2 )              ! before Brunt-Vaisala frequency
       
       !                                                     ! Vertical eddy viscosity and diffusivity coefficients
@@ -267,16 +217,11 @@
       ENDIF
 
-      IF( cp_cfg == "orca" ) THEN                           ! ORCA: Reduce vertical mixing in some specific areas
-         SELECT CASE ( jp_cfg )
-            CASE ( 05 )                         ! ORCA R2 configuration
-               avt  (:,:,2) = avt  (:,:,2) + 1.e-3 * upsrnfh(:,:)   ! increase diffusivity of rivers mouths
-            CASE ( 025 )                         ! ORCA R025 configuration
-               avt  (:,:,2) = avt  (:,:,2) + 2.e-3 * upsrnfh(:,:)   ! increase diffusivity of rivers mouths
-         END SELECT
+      IF( nn_runoff /=0 ) THEN                              ! increase diffusivity at rivers mouths
+         DO jk = 2, nkrnf   ;   avt(:,:,jk) = avt(:,:,jk) + rn_avt_rnf * rnfmsk(:,:)   ;   END DO
       ENDIF
 
       IF( ln_zdfevd )   CALL zdf_evd( kstp )                 ! enhanced vertical eddy diffusivity
 
-      IF( lk_zdfddm .AND. .NOT. lk_zdfkpp)   &
+      IF( lk_zdfddm .AND. .NOT. lk_zdfkpp )   &
          &              CALL zdf_ddm( kstp )                 ! double diffusive mixing
 
@@ -291,12 +236,9 @@
       ! N.B. ua, va, ta, sa arrays are used as workspace in this section
       !-----------------------------------------------------------------------
-
       IF( lk_ldfslp     )   CALL ldf_slp( kstp, rhd, rn2 )       ! before slope of the lateral mixing
-
 #if defined key_traldf_c2d
       IF( lk_traldf_eiv )   CALL ldf_eiv( kstp )                 ! eddy induced velocity coefficient
 #endif
 
-
 #if defined key_passivetrc
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -305,9 +247,6 @@
       ! N.B. ua, va, ta, sa arrays are used as workspace in this section
       !-----------------------------------------------------------------------
-
                              CALL trc_stp( kstp, indic )            ! time-stepping
-
-#endif
-
+#endif
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -316,25 +255,16 @@
       ! N.B. ua, va arrays are used as workspace in this section
       !-----------------------------------------------------------------------
-
                              ta(:,:,:) = 0.e0               ! set tracer trends to zero
                              sa(:,:,:) = 0.e0
 
                              CALL tra_sbc    ( kstp )       ! surface boundary condition
-
       IF( ln_traqsr      )   CALL tra_qsr    ( kstp )       ! penetrative solar radiation qsr
-
       IF( lk_trabbc      )   CALL tra_bbc    ( kstp )       ! bottom heat flux
-
       IF( lk_trabbl_dif  )   CALL tra_bbl_dif( kstp )       ! diffusive bottom boundary layer scheme
       IF( lk_trabbl_adv  )   CALL tra_bbl_adv( kstp )       ! advective (and/or diffusive) bottom boundary layer scheme
-
       IF( lk_tradmp      )   CALL tra_dmp    ( kstp )       ! internal damping trends
-
                              CALL tra_adv    ( kstp )       ! horizontal & vertical advection
-
       IF( n_cla == 1     )   CALL tra_cla    ( kstp )       ! Cross Land Advection (Update Hor. advection)
-
       IF( lk_zdfkpp )        CALL tra_kpp    ( kstp )       ! KPP non-local tracer fluxes
-
                              CALL tra_ldf    ( kstp )       ! lateral mixing
 #if defined key_agrif
@@ -342,7 +272,5 @@
 #endif
                              CALL tra_zdf    ( kstp )       ! vertical mixing
-
                              CALL tra_nxt( kstp )           ! tracer fields at next time step
-
       IF( ln_zdfnpc      )   CALL tra_npc( kstp )           ! update the new (t,s) fields by non
       !                                                     ! penetrative convective adjustment
@@ -365,13 +293,9 @@
       ! N.B. ta, sa arrays are used as workspace in this section 
       !-----------------------------------------------------------------------
-
-
                                ua(:,:,:) = 0.e0               ! set dynamics trends to zero
                                va(:,:,:) = 0.e0
 
                                CALL dyn_adv( kstp )           ! advection (vector or flux form)
-
                                CALL dyn_vor( kstp )           ! vorticity term including Coriolis
-
                                CALL dyn_ldf( kstp )           ! lateral mixing
 #if defined key_agrif
@@ -379,18 +303,11 @@
 #endif
                                CALL dyn_hpg( kstp )           ! horizontal gradient of Hydrostatic pressure
-
                                CALL dyn_zdf( kstp )           ! vertical diffusion
-
       IF( lk_dynspg_rl ) THEN
          IF( lk_obc    )       CALL obc_spg( kstp )           ! surface pressure gradient at open boundaries
       ENDIF
-                       indic=0
-!i bug lbc sur emp
-      CALL lbc_lnk( emp, 'T', 1. )
-!i
+                               indic=0
                                CALL dyn_spg( kstp, indic )    ! surface pressure gradient
-
                                CALL dyn_nxt( kstp )           ! lateral velocity at next time step
-
       IF( lk_vvl )             CALL dom_vvl                   ! vertical mesh at next time step
 
@@ -401,24 +318,14 @@
       ! N.B. ua, va, ta, sa arrays are used as workspace in this section
       !-----------------------------------------------------------------------
-
                        CALL oc_fz_pt                        ! ocean surface freezing temperature
-
                        CALL div_cur( kstp )                 ! Horizontal divergence & Relative vorticity
-
       IF( n_cla == 1 ) CALL div_cla( kstp )                 ! Cross Land Advection (Update Hor. divergence)
-
                        CALL wzv( kstp )                     ! Vertical velocity
 
-
-
-      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-      ! Control, and restarts
-      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      ! N.B. ua, va, ta, sa arrays are used as workspace in this section
-      !-----------------------------------------------------------------------
-      !                                                     ! Time loop: control and print
+      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+      ! Control and restarts
+      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                  CALL stp_ctl( kstp, indic )
       IF( indic < 0          )   CALL ctl_stop( 'step: indic < 0' )
-
       IF( kstp == nit000     )   CALL iom_close( numror )             ! close input  ocean restart file
       IF( lrst_oce           )   CALL rst_write  ( kstp )             ! write output ocean restart file
@@ -431,5 +338,5 @@
       !-----------------------------------------------------------------------
 
-      IF ( nstop == 0 ) THEN                                ! Diagnostics
+      IF( nstop == 0 ) THEN                                 ! Diagnostics:
          IF( lk_floats  )   CALL flo_stp( kstp )                 ! drifting Floats
          IF( lk_trddyn  )   CALL trd_dwr( kstp )                 ! trends: dynamics 
@@ -443,7 +350,6 @@
          IF( lk_diafwb  )   CALL dia_fwb( kstp )                 ! Fresh water budget diagnostics
          IF( ln_diaptr  )   CALL dia_ptr( kstp )                 ! Poleward TRansports diagnostics
-
-         !                                                 ! Outputs
-                            CALL dia_wri    ( kstp, indic )      ! ocean model: outputs
+         !                                                 ! outputs
+                            CALL dia_wri( kstp, indic )          ! ocean model: outputs
       ENDIF
 
Index: trunk/NEMO/TOP_SRC/TRP/trcadv_cen2.F90
===================================================================
--- trunk/NEMO/TOP_SRC/TRP/trcadv_cen2.F90	(revision 873)
+++ trunk/NEMO/TOP_SRC/TRP/trcadv_cen2.F90	(revision 888)
@@ -164,5 +164,5 @@
                zind(ji,jj,jk) =  MAX ( upsrnfh(ji,jj) * upsrnfz(jk),     &  ! changing advection scheme near runoff
                   &                    upsadv(ji,jj)                     &  ! in the vicinity of some straits
-#if defined key_lim3
+#if defined key_lim3 || defined key_lim2
                   &                  , tmask(ji,jj,jk)                   &  ! half upstream tracer fluxes
                   &                  * MAX( 0., SIGN( 1., fzptn(ji,jj)   &  ! if tn < ("freezing"+0.1 )
